# Re-bastardized version of spam-o-matic from Fedora's mash

import os
import shutil
from stat import *
import string
import sys
import tempfile
import re
import smtplib

from yum.constants import *
from yum.misc import getCacheDir

import koji
# HAAACK
import imp
sys.modules['repoclosure'] = imp.load_source("repoclosure","/usr/bin/repoclosure")
import repoclosure
sys.path.append('/usr/share/createrepo/')
sys.modules['createrepo'] = imp.load_source("createrepo","/usr/share/createrepo/genpkgmetadata.py")
import createrepo

deps = {}

def getReleaseVersion():
    verfile = open("/etc/redhat-release")
    fullver = verfile.readline()
    verfile.close()
    for item in fullver.split():
        if item[0].isdigit():
            return item.split(".")[0]

def generateConfig(disttype, arch, tmprepodir=""):
    (fd, conffile) = tempfile.mkstemp()
    relver = getReleaseVersion()
    confheader = """
[main]
debuglevel=2
logfile=/var/log/yum.log
pkgpolicy=newest
distroverpkg=centos-release
reposdir=/dev/null
cachedir=/var/tmp/yum
keepcache=0

[base]
name=CentOS - Base
baseurl=file:///army/centos/centos/%s/os/%s/

[update]
name=CentOS - Updates
baseurl=file:///army/centos/centos/%s/updates/%s/

[addons]
name=CentOS - Addons
baseurl=file:///army/centos/centos/%s/addons/%s/

[extras]
name=CentOS - Extras
baseurl=file:///army/centos/centos/%s/extras/%s/

[%s]
name=CentOS %s Tree
baseurl=file:///army/rpmprivate/centos/%s/%s/%s/

""" %(relver, arch, relver, arch, relver, arch, relver, arch, disttype, disttype, disttype, relver, arch)

    if tmprepodir != "":
        confheader += """
[candidates]
name=New packages
baseurl=file://%s

""" %(tmprepodir)


    print "I will now use this yum.conf file that I generated which contains"
    print "the repositories on which I will do the dependency checking:"
    print "-----------------------------------------------------------------"
    print confheader
    print "-----------------------------------------------------------------"
    os.write(fd,confheader)
    os.close(fd)
    return conffile


def libmunge(match):
    if match.groups()[1].isdigit():
        return "%s%d" % (match.groups()[0],int(match.groups()[1])+1)
    else:
        return "%s%s" % (match.groups()[0],match.groups()[1])

def getSrcPkg(pkg):
    if pkg.arch == 'src':
      return pkg.name
    srpm = pkg.returnSimple('sourcerpm')
    if not srpm:
        return None
    srcpkg = string.join(srpm.split('-')[:-2],'-')
    return srcpkg

def printableReq(pkg, dep):
    (n, f, v) = dep
    req = '%s' % n
    if f:
        flag = LETTERFLAGS[f]
        req = '%s %s' % (req, flag)
    if v:
        req = '%s %s' % (req, v)
    return "%s requires %s" % (pkg, req,)

def assignBlame(resolver, dep):
    def __addpackages(sack):
        for package in sack.returnPackages():
            p = getSrcPkg(package)
    
    # Given a dep, find potential responsible parties

    list = []
    
    # The dep itself
    list.append(dep)

    # Something that provides the dep
    __addpackages(resolver.whatProvides(dep, None, None))

    # Libraries: check for variant in soname
    if re.match("lib.*\.so\.[0-9]+",dep):
        new = re.sub("(lib.*\.so\.)([0-9])+",libmunge,dep)
        __addpackages(resolver.whatProvides(new, None, None))
        libname = dep.split('.')[0]
        __addpackages(resolver.whatProvides(libname, None, None))

    return list

def generateSpam(pkgname, treename):

    package = deps[pkgname]

    for s in package.keys():
        subpackage = package[s]
        for arch in subpackage.keys():
            brokendeps = subpackage[arch]

    data = """

%s has broken dependencies in the %s tree:
""" % (pkgname, treename)

    for s in package.keys():
        subpackage = package[s]
        for arch in subpackage.keys():
            data = data + "On %s:\n" % (arch)
            brokendeps = subpackage[arch]
            for dep in brokendeps:
                data = data + "\t%s\n" % printableReq(dep[0],dep[1])

    data = data + "Please resolve this as soon as possible.\n\n"
    
    return data


def filterout(deps):
    file = open('depcheck.ignore', 'r')
    inputtext = file.readlines()
    file.close()
    ignorelist = []
    for line in range(len(inputtext)):
        if inputtext[line][0] != "#" and inputtext[line] != "\n":
            ignoreitem = inputtext[line].split()
            if len(ignoreitem) == 3:
                ignorelist.append(ignoreitem)
            else:
                print "Could not parse depcheck.ignore, line ", line, ":"
                print "\t", inputtext[line]
                sys.exit(1)

    pkgs = deps.keys()
    for pkg in pkgs:
        remove = 0
        for (n, f, v) in deps[pkg]:
            if filterrules(ignorelist, pkg.name, n, f, v):
                remove = 1
        if remove == 1:
            deps.pop(pkg)
    return deps


def filterrules(ignorelist, name,requires,compare,version):
    # Hacky algorithm :) but it works
    for ignoreitem in range(len(ignorelist)):
        if ignorelist[ignoreitem][0] == "*":
            myname = name
        else:
            myname = ignorelist[ignoreitem][0]
        if ignorelist[ignoreitem][1] == "*":
            myrequires = requires
        else:
            myrequires = ignorelist[ignoreitem][1]
        if ignorelist[ignoreitem][2] == "*":
            myversion = version
        else:
            myversion = ignorelist[ignoreitem][2]

        if name == myname and requires == myrequires and version == myversion:
            return True
    return False

def createTmpRepo(packages, arch):
    kojisession = koji.ClientSession('http://192.168.226.90/kojihub')
    clientcert = '/etc/pki/koji/roji.pem'
    clientca = '/etc/pki/koji/koji_ca_cert.crt'
    serverca = '/etc/pki/koji/koji_ca_cert.crt'
    kojisession.ssl_login(clientcert, clientca, serverca)

    tempprefix = 'tmprepo-'+arch+'-'
    tempdir = tempfile.mkdtemp(prefix=tempprefix)
    print "Populating temporary repo " + tempdir + " with candidate packages."
    for package in packages:
        buildinfo = kojisession.getBuild(package)
        packagedir = '/mnt/koji/packages/'+buildinfo['name']+'/'+buildinfo['version']+'/'+buildinfo['release']+'/'+arch
        rpmfiles = os.listdir(packagedir)
        for file in rpmfiles:
            if file.endswith('.rpm'):
                print "Copying " + file
                shutil.copy2(packagedir+"/"+file,tempdir)
    print "Writing metadata:"
    createrepo.main([tempdir])
    return tempdir

def doit(type,packages=[]):
    i_am_broken = False

    for arch in ['x86_64', 'i386']:
        if packages != []:
            tmprepodir = createTmpRepo(packages, arch)
        else:
            tmprepodir = ""
        
        conffile = generateConfig(type, arch, tmprepodir)
        if not conffile:
            continue
        if arch == 'i386':
            carch = 'i686'
        elif arch == 'ppc':
            carch = 'ppc64'
        elif arch == 'sparc':
            carch = 'sparc64v'
        else:
            carch = arch
        print "I will next calculate the dependency chains."
        my = repoclosure.RepoClosure(config = conffile, arch = [carch])
        cachedir = getCacheDir(reuse=False)
        my.repos.setCacheDir(cachedir)
        print "Processing metadata returned from repoclosure."
        my.readMetadata()
        print "Now calculate the dependencies... It might take a minute or two."
        baddeps = my.getBrokenDeps(newest = True)
        baddeps=filterout(baddeps)
        pkgs = baddeps.keys()
        tmplist = [(x.returnSimple('name'), x) for x in pkgs]
        tmplist.sort()
        pkgs = [x for (key, x) in tmplist]
        if len(pkgs) > 0:
            i_am_broken = True
            print "Broken deps for %s" % (arch,)
            print "----------------------------------------------------------"
        else:
            print "We are clean. No broken dependencies."
        for pkg in pkgs:
            srcpkg = getSrcPkg(pkg)


            if not deps.has_key(srcpkg):
                deps[srcpkg] = {}

            pkgid = "%s-%s" % (pkg.name, pkg.printVer())

            if not deps[srcpkg].has_key(pkgid):
                deps[srcpkg][pkgid] = {}

            broken = []
            for (n, f, v) in baddeps[pkg]:
                print "\t%s" % printableReq(pkg, (n, f, v))
                blamelist = assignBlame(my, n)
                broken.append( (pkg, (n, f, v), blamelist) )
                addtobrokenlist = True

                deps[srcpkg][pkgid][arch] = broken

        print "Clean up: removing the temporary repo dir: ", tmprepodir
        shutil.rmtree(tmprepodir, ignore_errors = True)
        os.unlink(conffile)
        print "Clean up: removing the cachedir: ", cachedir
        shutil.rmtree(cachedir, ignore_errors = True)
        print "Done!\n\n"

    pkglist = deps.keys()

    spamdata=""
    for pkg in pkglist:
        spamdata += generateSpam(pkg, type)

    if i_am_broken == True:
        email_subject = "CentOS - Broken dependencies"
        email_body = spamdata
        return ["broken", email_subject, email_body]
    else:
        return ["healthy","",""]
